<?php
/**
 * Created by Sebastian Viereck IT-Services
 * www.sebastianviereck.de
 * Date: 17.03.14
 * Time: 15:39
 */

//https://developers.google.com/chart/interactive/docs/gallery/geomap?csw=1#markersexample
class OpenLayers extends CWidget
{
    public $cities;


    public function init()
    {
        $cs = Yii::app()->getClientScript();
        $cs->registerScriptFile("http://openlayers.org/api/OpenLayers.js");

        $cities = $this->cities;
        foreach ($cities as $city)
        {
            $citiesJs[] = $city->getAllAttributes();
        }
        //$countryJs = $this->country->getAllAttributes();
        $this->render("cities",
            array(
                "citiesJs" => $citiesJs,
                "zoomFactor" => $this->getZoomFactor($cities),
                "center" => $this->getCenterFromCities($cities),
            )
        );

    }

    private function getMaxLatDiff($cities)
    {
        $maxLat = false;
        $minLat = false;
        foreach ($cities as $city)
        {
            $lat = $city->latitude;
            if ($lat)
            {
                if ($maxLat)
                {
                    if ($maxLat < $lat)
                    {
                        $maxLat = $lat;
                    }
                }
                else
                {
                    $maxLat = $lat;
                }
                if ($minLat)
                {
                    if ($minLat > $lat)
                    {
                        $minLat = $lat;
                    }
                }
                else
                {
                    $minLat = $lat;
                }
            }
        }

        return abs($maxLat - $minLat);
    }

    private function getMaxLngDiff($cities)
    {
        $maxLng = false;
        $minLng = false;
        foreach ($cities as $city)
        {
            $Lng = $city->longitude;
            if ($Lng)
            {
                if ($maxLng)
                {
                    if ($maxLng < $Lng)
                    {
                        $maxLng = $Lng;
                    }
                }
                else
                {
                    $maxLng = $Lng;
                }
                if ($minLng)
                {
                    if ($minLng > $Lng)
                    {
                        $minLng = $Lng;
                    }
                }
                else
                {
                    $minLng = $Lng;
                }
            }
        }

        return abs($maxLng - $minLng);
    }

    private function getZoomFactor($cities)
    {
        if ($cities)
        {
            $maxLatDiff = $this->getMaxLatDiff($cities);
            $maxLngDiff = $this->getMaxLngDiff($cities);
            $maxDiff = max(array($maxLatDiff, $maxLngDiff));


            if ($maxDiff > 40)
            {
                return 3;
            }
            //Australien: 37,5 http://www.routenplaner24.de/n/landkarte/australien/au
            else if ($maxDiff > 15)
            {
                return 4;
            }
            //Argentienien 13,5  http://www.routenplaner24.de/n/landkarte/argentinien/ar
            else if ($maxDiff > 7)
            {
                return 5;
            }
            //Ägypten 5,5  http://www.routenplaner24.de/n/landkarte/%C3%84gypten/eg
            else if ($maxDiff > 4)
            {
                return 6;
            }
            //Benin 120000 http://www.routenplaner24.de/n/landkarte/benin/bj
            else if ($maxDiff > 3)
            {
                return 7;
            }
            //http://www.routenplaner24.de/n/landkarte/deutschland/nordrhein-westfalen/2861876
            else if ($maxDiff > 1.5)
            {
                return 8;
            }
            else if ($maxDiff > 1)
            {
                return 9;
            }
            else if ($maxDiff > 0.5)
            {
                return 10;
            }
            //Andorra 0.25 http://www.routenplaner24.de/n/landkarte/andorra/ad
            else
            {
                return 11;
            }

        }
        //Default
        return 8;
        /*$areainsqkm = $this->country->areainsqkm;
        //Australien: 7.686.850  http://www.routenplaner24.de/n/landkarte/australien/au
        if($areainsqkm > 5000000){
            return 3;
        }
        //Argentienien 2766890  http://www.routenplaner24.de/n/landkarte/argentinien/ar
        else if($areainsqkm > 2000000){
            return 4;
        }
        //Ägypten 1001450  http://www.routenplaner24.de/n/landkarte/%C3%84gypten/eg
        else if($areainsqkm > 1000000){
            return 5;
        }
        //
        else if($areainsqkm > 500000){
            return 6;
        }
        //Benin 120000 http://www.routenplaner24.de/n/landkarte/benin/bj
        else if($areainsqkm > 100000){
            return 7;
        }
        //Armenien 27000 http://www.routenplaner24.de/n/landkarte/armenien/am
        else if($areainsqkm > 20000){
            return 8;
        }
        else if($areainsqkm > 10000){
            return 9;
        }
        else if($areainsqkm > 1000){
            return 10;
        }
        //Andorra 450 http://www.routenplaner24.de/n/landkarte/andorra/ad
        else{
            return 11;
        }*/
    }
    private function getCenterFromCities($cities){
        if ($cities)
        {
            foreach($cities as $city){
                $lng = $city->longitude;
                $lat = $city->latitude;
                if($lng && $lat){
                    $allLat[] = $lat;
                    $allLng[] = $lng;
                }
            }
            $maxLat = max($allLat);
            $minLat = min($allLat);
            $centerLat = $maxLat - ($maxLat - $minLat)/2;

            $maxLng = max($allLng);
            $minLng = min($allLng);
            $centerLng = $maxLng - ($maxLng - $minLng)/2;
            return array("latitude" => $centerLat, "longitude" => $centerLng);
        }
    }

}