<?php
/**
 * Created by Sebastian Viereck IT-Services
 * www.sebastianviereck.de
 * Date: 17.03.14
 * Time: 15:41
 */
/* @var $country Countries */
?>
<div  class ='open_street_map' id="open_layers_country_map">

</div>
<!--<div id="open_street_map_contribution">
    © OpenStreetMap contributors
    <!--© <a href="http://www.openstreetmap.org">OpenStreetMap</a>
    und <a href="http://www.openstreetmap.org/copyright">Mitwirkende</a>,
    <a href="http://creativecommons.org/licenses/by-sa/2.0/deed.de">CC-BY-SA</a>
</div>-->
<script type='text/javascript'>

    $(document).ready(function(){
        initOpenLayer();
    });

    function initOpenLayer() {
        var country = <?php echo json_encode($countryJs)?>;
        var cities = <?php echo json_encode($citiesJs)?>;
        var center = <?php echo json_encode($center)?>;
        console.log(center);
        console.log(cities);


        var lonlat = new OpenLayers.LonLat(center.longitude, center.latitude).transform(
            new OpenLayers.Projection("EPSG:4326"), // transform from WGS 1984
            new OpenLayers.Projection("EPSG:900913") // to Spherical Mercator
        );

        var zoom = <?php echo $zoomFactor ? $zoomFactor : 4 ?>;
        console.log("zoom:" + zoom);
        var overlay = new OpenLayers.Layer.Vector('Overlay', {
            styleMap: new OpenLayers.StyleMap({
                externalGraphic: '../img/marker.png',
                graphicWidth: 20, graphicHeight: 24, graphicYOffset: -24,
                title: '${tooltip}'
            })
        });

        map = new OpenLayers.Map({
            div: "open_layers_country_map",
            projection: "EPSG:4326",
            layers: [new OpenLayers.Layer.OSM(), overlay],
            center: lonlat,
            zoom: zoom
        });






        var markers = new OpenLayers.Layer.Markers( "Markers" );

        var size = new OpenLayers.Size(21,25);
        var offset = new OpenLayers.Pixel(-(size.w/2), -size.h);


        // The overlay layer for our marker, with a simple diamond as symbol
        var overlay = new OpenLayers.Layer.Vector('Overlay', {
            styleMap: new OpenLayers.StyleMap({
                //externalGraphic: '../img/marker.png',
                //graphicWidth: 20, graphicHeight: 24, graphicYOffset: -24,
                title: '${tooltip}'
            })
        });
        var currentPopup;
        var markerClick = function(evt) {
            if (currentPopup != null && currentPopup.visible()) {
                currentPopup.hide();
            }

            if (this.popup == null) {
                this.popup = this.createPopup(this.closeBox);
                map.addPopup(this.popup);
                this.popup.show();
            } else {
                this.popup.toggle();
            }
            currentPopup = this.popup;
            OpenLayers.Event.stop(evt);
        };

        var markerMouseover = function(evt) {
            if (currentPopup != null && currentPopup.visible() && this.popup != currentPopup) {
                currentPopup.hide();
            }

            if (this.popup == null) {
                this.popup = this.createPopup(this.closeBox);
                map.addPopup(this.popup);
                this.popup.show();
            }else {
                this.popup.toggle();
            }
            currentPopup = this.popup;
            OpenLayers.Event.stop(evt);
        };

        var popupClass = OpenLayers.Class(OpenLayers.Popup.FramedCloud, {
            "autoSize": true,
            "minSize": new OpenLayers.Size(100, 50),
            "maxSize": new OpenLayers.Size(200, 300),
            "keepInMap": true
        });

        map.addLayer(markers);
        $.each(cities, function(index, city){
            var lonlat = new OpenLayers.LonLat(city.longitude, city.latitude).transform(
                new OpenLayers.Projection("EPSG:4326"), // transform from WGS 1984
                new OpenLayers.Projection("EPSG:900913") // to Spherical Mercator
            );
            if(cities.length > 100){
                var icon = new OpenLayers.Icon('http://www.routenplaner24.de/n/images/mapiconscollection-numbers-b0c845-iphone/green.png', size, offset);
            }
            else
            {
                var icon = new OpenLayers.Icon('http://www.routenplaner24.de/n/images/mapiconscollection-numbers-b0c845-iphone/number_' + (index + 1) + '.png', size, offset);
            }



            var marker = new OpenLayers.Marker(lonlat, icon);

            var feature = new OpenLayers.Feature(marker, lonlat);
            feature.closeBox = true;
            feature.popupClass = popupClass;
            feature.data.popupContentHTML = '<b>' + city.nameGerman + '</b><br>' + city.populationFormatted + '<br>'  + city.link;
            feature.data.overflow = "auto";

            marker.events.register("mousedown", feature, markerClick);
            marker.events.register("mouseover", feature, markerMouseover);
            markers.addMarker(marker);

        });


        map.setCenter(lonlat, zoom);
    }

</script>


